#include "speaker.h"
#include <stdlib.h>

bool callback(void);

int main( void )
{
  initialize(callback);
  
  while(!isDone())
  {}
  
  return 0;
}

struct MorseCode
{
  char character;
  signed char code[9]; // Muss eins lnger sein als der lngste Code!
};

typedef struct MorseCode MorseCode;

bool callback(void)
{
  static const MorseCode dictionary[] =
  {
    {'A', {1, -1, 3, -3}}, // Rest automatisch mit Nullen gefllt
    {'E', {1, -3}},
    {'H', {1, -1, 1, -1, 1, -1, 1, -3}},
    {'L', {1, -1, 3, -1, 1, -1, 1, -3}},
    {'O', {3, -1, 3, -1, 3, -3}},
    {'T', {3, -3}},
    {'W', {1, -1, 3, -1, 3, -3}},
    {' ', {-4}}
  };
  static const int length = 3;
  static const char text[] = "HALLO WELT";
  static int currentDictionarySymbol = -1; // -1 heit: noch zu bestimmen
  static int position = 0;
  static int step = 0;
  static int subStep = 0;  

  if(currentDictionarySymbol < 0)
  {
    for(int i = 0; i < sizeof dictionary/sizeof (MorseCode); i++)
    {
      if(dictionary[i].character == text[position])
      {
        currentDictionarySymbol = i;
        break;
      }
    }
  }
  
  int d = length * dictionary[currentDictionarySymbol].code[step];
  if(subStep == 0)
  {
    if(d >= 0)
    {
      soundOn();
    }
    else
    {
      soundOff();
    }
  }
  subStep++;
  if(subStep == abs(d))
  {
    subStep = 0;
    step++;
    if(dictionary[currentDictionarySymbol].code[step] == 0)
    {
      position++;
      step = 0;
      currentDictionarySymbol = -1;
    }      
  }
  
  return text[position] == '\0';
}